Attribute VB_Name = "modTypeLibraryFunctions"
' -----------------------------------------------------------------
' Copyright by Philip Sakellaropoulos - KNOWLEDGE, 2000-2001
' -----------------------------------------------------------------
' Some API declarations
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileSectionNames Lib "kernel32" Alias "GetPrivateProfileSectionNamesA" (ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Public Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
' copied from TLI documentation
Function GetSearchType(ByVal SearchData As Long) As TliSearchTypes
  If SearchData And &H80000000 Then
    GetSearchType = ((SearchData And &H7FFFFFFF) \ &H1000000 And &H7F&) Or &H80
  Else
    GetSearchType = SearchData \ &H1000000 And &HFF&
  End If
End Function
Function GetTypeInfoNumber(ByVal SearchData As Long) As Integer
  GetTypeInfoNumber = SearchData And &HFFF&
End Function
Function GetLibNum(ByVal SearchData As Long) As Integer
  SearchData = SearchData And &H7FFFFFFF
  GetLibNum = ((SearchData \ &H2000& And &H7) * &H100&) Or _
               (SearchData \ &H10000 And &HFF&)
End Function
Function GetHidden(ByVal SearchData As Long) As Boolean
    If SearchData And &H1000& Then GetHidden = True
End Function
Function BuildSearchData( _
   ByVal TypeInfoNumber As Long, _
   ByVal SearchTypes As TliSearchTypes, _
   Optional ByVal LibNum As Long, _
   Optional ByVal Hidden As Boolean = False) As Long
  If SearchTypes And &H80 Then
    BuildSearchData = _
      (TypeInfoNumber And &H1FFF&) Or _
      ((SearchTypes And &H7F) * &H1000000) Or &H80000000
  Else
    BuildSearchData = _
      (TypeInfoNumber And &H1FFF&) Or _
      (SearchTypes * &H1000000)
  End If

  If LibNum Then
    BuildSearchData = BuildSearchData Or _
      ((LibNum And &HFF) * &H10000) Or _
      ((LibNum And &H700) * &H20&)
  End If
  If Hidden Then
    BuildSearchData = BuildSearchData Or &H1000&
  End If
End Function
' Helper Function from Microsoft
' Modified to return Parameter info into arrays
Function PrototypeMember( _
  ByRef ParamNames() As String, ByRef ParamTypes() As String, _
  ByRef ParamOptional() As String, ByRef ParamDefValue() As String, _
  ByRef MemberType As String, ByRef MemberHelpString As String, ByRef RetType As String, _
  TLInf As TypeLibInfo, ByVal SearchData As Long, _
  ByVal InvokeKinds As InvokeKinds, _
  Optional ByVal MemberId As Long = -1, _
  Optional ByVal MemberName As String) As String
Dim pi As ParameterInfo
Dim fFirstParameter As Boolean
Dim fIsConstant As Boolean
Dim fByVal As Boolean
Dim retVal As String
Dim ConstVal As Variant
Dim strTypeName As String
Dim VarTypeCur As Integer
Dim fDefault As Boolean, fOptional As Boolean, fParamArray As Boolean
Dim TIType As TypeInfo
Dim TIResolved As TypeInfo
Dim TKind As TypeKinds
Dim iCount As Long, pos As Long

MemberType = "": RetType = "": MemberHelpString = ""
  With TLInf
    fIsConstant = GetSearchType(SearchData) And tliStConstants
    With .GetMemberInfo(SearchData, InvokeKinds, MemberId, MemberName)
      MemberHelpString = .HelpString
      retVal = InvokeInfo(InvokeKinds) & " "
      pos = InStr(1, retVal, " ")
      If pos > 1 Then MemberType = Left(retVal, pos - 1)
      'If fIsConstant Then
      '  retVal = "Const "
      If InvokeKinds = INVOKE_FUNC Or InvokeKinds = INVOKE_EVENTFUNC Then
        Select Case .ReturnType.VarType
          Case VT_VOID, VT_HRESULT
            retVal = "Sub "
            'RetType = "-"
          Case Else
            retVal = "Function "
        End Select
      'Else
      '  retVal = "Property "
      End If
      retVal = retVal & .Name
      With .Parameters
        ' put values at indexes 1 to Count
        ReDim ParamNames(.Count) As String
        ReDim ParamTypes(.Count) As String
        ReDim ParamOptional(.Count) As String
        ReDim ParamDefValue(.Count) As String
        If .Count Then
          retVal = retVal & "("
          fFirstParameter = True
          fParamArray = .OptionalCount = -1
          iCount = 0
          For Each pi In .Me
            iCount = iCount + 1
            ParamNames(iCount) = pi.Name
            ParamOptional(iCount) = "No" ' by default, may change
            If Not fFirstParameter Then
              retVal = retVal & ", "
            End If
            fFirstParameter = False
            fDefault = pi.Default
            fOptional = fDefault Or pi.Optional
            If fOptional Then
              If fParamArray Then
                'This will be the only optional parameter
                retVal = retVal & "[ParamArray "
              Else
                retVal = retVal & "["
              End If
              ParamOptional(iCount) = "Yes"
            End If
            With pi.VarTypeInfo
              Set TIType = Nothing
              Set TIResolved = Nothing
              TKind = TKIND_MAX
              VarTypeCur = .VarType
              If (VarTypeCur And Not (VT_ARRAY Or VT_VECTOR)) = 0 Then
              'If Not .TypeInfoNumber Then 'This may error, don't use here
                On Error Resume Next
                Set TIType = .TypeInfo
                If Not TIType Is Nothing Then
                  Set TIResolved = TIType
                  TKind = TIResolved.TypeKind
                  Do While TKind = TKIND_ALIAS
                    TKind = TKIND_MAX
                    Set TIResolved = TIResolved.ResolvedType
                    If Err Then
                      Err.Clear
                    Else
                      TKind = TIResolved.TypeKind
                    End If
                  Loop
                End If
                Select Case TKind
                  Case TKIND_INTERFACE, TKIND_COCLASS, TKIND_DISPATCH
                    fByVal = .PointerLevel = 1
                  Case TKIND_RECORD
                    'Records not passed ByVal in VB
                    fByVal = False
                  Case Else
                    fByVal = .PointerLevel = 0
                End Select
                ' sos remove ByVal to simplify syntax, leave only ByRef
                ' If fByVal Then retVal = retVal & "ByVal "
                retVal = retVal & pi.Name
                If VarTypeCur And (VT_ARRAY Or VT_VECTOR) Then retVal = retVal & "()"
                If TIType Is Nothing Then 'Error
                  retVal = retVal & " As ?"
                Else
                  If .IsExternalType Then
                    ParamTypes(iCount) = .TypeLibInfoExternal.Name & "." & TIType.Name
                    retVal = retVal & " As " & ParamTypes(iCount)
                  Else
                    ParamTypes(iCount) = TIType.Name
                    retVal = retVal & " As " & ParamTypes(iCount)
                  End If
                End If
                On Error GoTo 0
              Else
                ' sos Remove ByVal to simplify syntax
                ' If .PointerLevel = 0 Then retVal = retVal & "ByVal "
                retVal = retVal & pi.Name
                If VarTypeCur <> vbVariant Then
                  strTypeName = TypeName(.TypedVariant)
                  ParamTypes(iCount) = strTypeName
                  If VarTypeCur And (VT_ARRAY Or VT_VECTOR) Then
                    retVal = retVal & "() As " & Left(strTypeName, Len(strTypeName) - 2)
                  Else
                    retVal = retVal & " As " & strTypeName
                  End If
                Else ' variant
                  ParamTypes(iCount) = "Variant"
                End If
              End If
              If fOptional Then
                If fDefault Then
                  ParamDefValue(iCount) = ProduceDefaultValue(pi.DefaultValue, TIResolved)
                  If Len(ParamDefValue(iCount)) > 0 Then
                    retVal = retVal & " = " & ParamDefValue(iCount)
                  End If
                End If
                retVal = retVal & "]"
              End If
            End With
          Next
          retVal = retVal & ")"
        End If
      End With
      If fIsConstant Then
        ConstVal = .Value
        retVal = retVal & " = " & ConstVal
        Select Case VarType(ConstVal)
          Case vbInteger, vbLong
            If ConstVal < 0 Or ConstVal > 15 Then
              retVal = retVal & " (&H" & Hex$(ConstVal) & ")"
            End If
        End Select
      Else
        With .ReturnType
          VarTypeCur = .VarType
          If VarTypeCur = 0 Or (VarTypeCur And Not (VT_ARRAY Or VT_VECTOR)) = 0 Then
          'If Not .TypeInfoNumber Then 'This may error, don't use here
            On Error Resume Next
            If Not .TypeInfo Is Nothing Then
              If Err Then 'Information not available
                RetType = "?"
                retVal = retVal & " As ?"
              Else
                If .IsExternalType Then
                  RetType = .TypeLibInfoExternal.Name & "." & .TypeInfo.Name
                  retVal = retVal & " As " & RetType
                Else
                  RetType = .TypeInfo.Name
                  retVal = retVal & " As " & RetType
                End If
              End If
            End If ' err
            If VarTypeCur And (VT_ARRAY Or VT_VECTOR) Then
              retVal = retVal & "()"
              RetType = RetType & "()"
            End If
            On Error GoTo 0
          Else
            Select Case VarTypeCur
              Case VT_VOID, VT_HRESULT ' VT_VARIANT -> we choose to show the As Variant
              Case Else
                strTypeName = TypeName(.TypedVariant)
                If VarTypeCur And (VT_ARRAY Or VT_VECTOR) Then
                  retVal = retVal & "() As " & Left$(strTypeName, Len(strTypeName) - 2)
                Else
                  retVal = retVal & " As " & strTypeName
                End If
                RetType = strTypeName
            End Select
          End If
        End With '.ReturnType
      End If
      PrototypeMember = retVal
      ' & vbCrLf & "  " & "Member of " & TLInf.Name & "." & _
      ' TLInf.GetTypeInfo(SearchData And &HFFFF&).Name & vbCrLf & "  " & .HelpString
    End With
  End With
End Function
' Helper function copied from Microsoft Documentation
Public Function ProduceDefaultValue(DefVal As Variant, ByVal tliTypeInfo As TypeInfo) As String
Dim lngTrackVal As Long
Dim MI As MemberInfo
Dim tliTypeKinds As TypeKinds
    
If tliTypeInfo Is Nothing Then
    Select Case VarType(DefVal)
        Case vbString
            If Len(DefVal) Then
                ProduceDefaultValue = """" & DefVal & """"
            End If
        Case vbBoolean 'Always show for Boolean
            ProduceDefaultValue = DefVal
        Case vbDate
            If DefVal Then
                ProduceDefaultValue = "#" & DefVal & "#"
            End If
        Case Else 'Numeric Values
            If DefVal <> 0 Then
                ProduceDefaultValue = DefVal
            End If
    End Select
Else
    'Resolve constants to their enums
    tliTypeKinds = tliTypeInfo.TypeKind
    Do While tliTypeKinds = TKIND_ALIAS
        tliTypeKinds = TKIND_MAX
        On Error Resume Next
        Set tliTypeInfo = tliTypeInfo.ResolvedType
        If Err = 0 Then
            tliTypeKinds = tliTypeInfo.TypeKind
        End If
        On Error GoTo 0
    Loop
    If tliTypeInfo.TypeKind = TKIND_ENUM Then
        lngTrackVal = DefVal
        For Each MI In tliTypeInfo.Members
            If MI.Value = lngTrackVal Then
                ProduceDefaultValue = MI.Name
                Exit For
            End If
        Next
    End If
End If
End Function
' Helper function copied from Microsoft Documentation
Function InvokeInfo(ByVal InvKinds As TLI.InvokeKinds) As String
  If InvKinds And INVOKE_CONST Then
    InvokeInfo = "Constant"
    Exit Function
  End If
  Select Case InvKinds
    Case INVOKE_EVENTFUNC
      InvokeInfo = "Event"
    Case INVOKE_FUNC
      InvokeInfo = "Method"
    Case INVOKE_PROPERTYGET
      InvokeInfo = "Property Get"
    Case INVOKE_PROPERTYPUT
      InvokeInfo = "Property Let"
    Case INVOKE_PROPERTYPUTREF
      InvokeInfo = "Property Set"
    Case INVOKE_PROPERTYPUT Or INVOKE_PROPERTYGET
      InvokeInfo = "Property Get/Let"
    Case INVOKE_PROPERTYPUTREF Or INVOKE_PROPERTYGET
      InvokeInfo = "Property Get/Set"
    Case INVOKE_PROPERTYPUTREF Or INVOKE_PROPERTYPUT
      InvokeInfo = "Property Let/Set"
    Case INVOKE_PROPERTYGET Or INVOKE_PROPERTYPUTREF Or INVOKE_PROPERTYPUT
      InvokeInfo = "Property Get/Let/Set"
  End Select
End Function
Function InvokeInfoShort(ByVal InvKinds As TLI.InvokeKinds) As String
  Dim pos As Long
  InvokeInfoShort = InvokeInfo(InvKinds)
  pos = InStr(1, InvokeInfoShort, " ")
  If pos > 1 Then
    InvokeInfoShort = Left(InvokeInfoShort, pos - 1)
  End If
  Exit Function
End Function
' helper function to find if a string is contained in the array
Function FindStringInArray(str1, FindArray) As Long
FindStringInArray = -1
For i = 0 To UBound(FindArray)
  If FindArray(i) = str1 Then
    FindStringInArray = i
    Exit Function
  End If
Next
End Function
' helper function to find the base file name (without suffix) from a full path
Public Function GetBaseFile(File As String) As String
Dim pos1 As Long, pos2 As Long
pos1 = InStrRev(File, "\"): pos2 = InStrRev(File, ".")
GetBaseFile = Mid(File, pos1 + 1, pos2 - pos1 - 1)
End Function

