<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:msxml="urn:schemas-microsoft-com:xslt"
  xmlns:state="http://www.vbxml.com/state" 
  xmlns:str="http://www.vbxml.com/str" 
  >
  
  <msxml:script language="VBScript" implements-prefix="state">'<![CDATA[

  Const ForReading = 1
  Const ForWriting = 2
  Const ForAppending = 8
  dim fso
  set fso=createObject("Scripting.FileSystemObject")
  Dim gFileList
  
  ' --- functions from the book "Beginning XML" ---
  function document(url)
   Set xmlDoc = CreateObject("MSXML2.DOMDocument")
   xmlDoc.async=false
   xmlDoc.load url
   set document = xmlDoc
  end function
  
  function saveDoc2File(dir,filename,newDoc,OverWrite)
   saveDoc2File=""
   If Not fso.FolderExists(dir) Then fso.CreateFolder dir
   fullfile = dir & filename
   if OverWrite="no" then 
     if fso.FileExists(fullfile) then
	   exit function
	 end if
   end if
   set saveDoc2File = persistDocument(fullfile,newDoc)
  end function
  
  function persistDocument(url,newDoc)
   set doc=CreateObject("MSXML2.DOMDocument")
   doc.async=false
   set node=newDoc(0).cloneNode(true)
   doc.appendChild node
   ' my function to remove XML namespace attributes from first node
   call RemoveDocElemAttributes(doc)
   doc.save url
   set persistDocument=doc
  end function
  
  function transformDocument(source,filter,paramsbject)
    set sourceDoc=CreateObject("MSXML2.FreeThreadedDOMDocument")
    set filterDoc=CreateObject("MSXML2.FreeThreadedDOMDocument")
    set resultDoc=CreateObject("MSXML2.FreeThreadedDOMDocument")
    if typename(source)="String" Then
      sourceDoc.async=false
      sourceDoc.load source
    else
      set sourceDoc.documentElement=source.documentElement.cloneNode(true)
    end if
    if typename(filter)="String" then
      filterDoc.async=false
      filterDoc.load filter
    else
      set filterDoc.documentElement=filter.documentElement.cloneNode(true)
    end if
    
    if not typename(paramsObject)="String" then
      for each paramNode in paramsObject
        set nameNode=paramNode.selectSingleNode(".//@name")
        paramName=nameNode.text
        set valueNode=paramNode.selectSingleNode(".//@select")
        paramValue=valueNode.text
        set curParamNode=filterDoc.selectSingleNode("//xsl:param[@name='" _
         + paramName + "']")
        if not curParamNode is nothing then
          curParamNode.setAttribute "select",paramValue
        end if
      next
    end if
    sourceDoc.transformNodeToObject filterDoc,resultDoc
    set transformDocument=resultDoc
  end function
  
  function getCurrentDate()
    dt=now
    getCurrentDate= _
      right("00"+cstr(datePart("d",dt)),2) + "-" + _
      right("00"+cstr(datePart("m",dt)),2) + "-" + _
      cstr(datePart("yyyy",dt))
  end function
  
  function encapsulateXML(text,resourceURL)
    set xmlDoc=createObject("MSXML2.DOMDocument")
    xmlDoc.async=false
    xmlDoc.loadXML text
    errorReason=xmlDoc.parseError.reason
    if errorReason="" then
     xmlDoc.save resourceURL
    else
      divText="<div>"+text+"</div>"
	  xmlDoc.loadXML divText
	  errorReason=xmlDoc.parseError.reason
	  if errorReason="" then
	    xmlDoc.save resourceURL
	  else
	    div2Text="<div><![CDATA["+text+"]]&gt;</div>"
	    xmlDoc.saveXML div2Text
	  end if
	end if
	set encapsulateXML=xmlDoc
  end function
  
  function deleteFile(filepath)
    fso.DeleteFile(filepath)
    deleteFile=filepath
  end function
  
  ' --- my functions
  function saveTextFile(filepath,text)
	set fOut = fso.OpenTextFile(filepath, ForWriting, True)
    fOut.Write text
	fOut.Close
    saveTextFile=filepath
  end function

  ' =======================================================================
  ' Save list of HTML files used in the help file into the Help Project file
  ' Project file has an INI file structure
  ' HTML list of files goes into the [FILES] section
  function SaveListInHHP(Full_HHP_file)
  
    'backup old HHP file
    Full_HHP_file_copy = Left(Full_HHP_file,Len(Full_HHP_file)-4) & "_copy.hhp"
    fso.CopyFile Full_HHP_file,Full_HHP_file_copy,True
    ' read old contents
    set fIn = fso.OpenTextFile(Full_HHP_file, ForReading)
    conts = fIn.ReadAll
    fIn.Close
    fsec = "[FILES]"
    pos1 = Instr(1,conts,fsec) + Len(fsec)
    pos2 = Instr(pos1,conts,"[")
    ' part of file up to FILES section
    ' part1 = Left(conts,pos1-1)
    if pos2>0 Then
      part1 = Left(conts,pos2-1)
    else
      part1=conts
    end if
    part1 = trim(part1)
    outConts = part1
    arrList=Split(gFileList,vbCrLf)
    For i=0 to UBound(arrList)
      If Instr(1,part1,arrList(i)) < 1 Then
        outConts = outConts & arrList(i) & vbCrLf
      end if
    Next
    ' outConts = part1 & vbCrLf & gFileList & vbCrLf
     ' append next section up to end
    if pos2>0 then outConts = outConts & Mid(conts,pos2)
    SaveListInHHP = saveTextFile(Full_HHP_file,outConts)
  end function
  
  ' =======================================================================
  ' add file to the list of files, saved in a global value
  ' not nice solution but i could not find better
  ' MSXML script functions do not accept out variables
  function AddFileToList(file)
    gFileList = gFileList & file & vbCrLf
    AddFileToList = True
  end function

  ' save the contents of the type library and preserve other elements
  ' this is done by replacing the old respective elements
  ' LibContents have the form <LI> <OBJECT type="text/sitemap"><param name="Name" value="Object ChannelTelephone"

  Const START_COMM = "<!-- Start DocLibTool content -->"
  Const END_COMM = "<!-- End DocLibTool content -->"
  Const HH_DTD = "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML//EN"">"
  Const SITEMAP1 = "<!-- Sitemap 1.0 -->"
  Const SITEMAP2 = "<!--Sitemap 1.0-->"
  
  function GetDirFromFile(file)
    GetDirFromFile = ""
    pos = instrrev(file,"\")
    if pos > 1 then GetDirFromFile = Left(file,pos-1)
  end function
  
  sub ReplaceIterative(str,f,r)
    Do while Instr(1,str,f)>0 
      str = Replace(str,f,r)
    Loop
  end sub

  function SaveLibContentsInHHC_HHK(LibContents,Full_out_file)
   Dim fOldFile,oldConts,fLog

   SaveLibContentsInHHC_HHK=""
   sDir = GetDirFromFile(Full_out_file)
   set fLog = fso.OpenTextFile(sDir & "\log.txt",ForAppending,True)
   call fLog.writeline("-------------------- " & Full_out_file & " ------------------------")
   
   set doc=CreateObject("MSXML2.DOMDocument")
   doc.async=false
   set node=LibContents(0).cloneNode(true)
   doc.appendChild node
   call RemoveDocElemAttributes(doc)
    ' read old
    ' flog.writeline doc.xml
    ' delete file if it has zero size
    if fso.FileExists(Full_out_file) Then
      if fso.GetFile(Full_out_file).Size = 0 Then call fso.DeleteFile(Full_out_file)
    end if
    If Not fso.FileExists(Full_out_file) Then
      outConts = "<HTML>" & START_COMM &  doc.xml & END_COMM & "</HTML>"
      SaveLibContentsInHHC_HHK = saveTextFile(Full_out_file,outConts)
    Else
    ' ------------ Make a backup of existing contents file --------------------------
      copied = Left(Full_out_file,Len(Full_out_file)-4) + "_copy" + Right(Full_out_file,4)
      call fso.CopyFile(Full_out_file,copied,True)
      set fOldFile = fso.OpenTextFile(Full_out_file,ForReading)
      oldConts = fOldFile.ReadAll
      fOldFile.Close
      pos0 = Instr(1,oldConts,HH_DTD)
      pos1 = Instr(1,oldConts,SITEMAP1)
      pos2 = Instr(1,oldConts,SITEMAP2)
      flog.writeline "pos1=" & pos1 & ", pos2=" & pos2
      
      if pos0 >= 1 Or pos1 >= 1 Or pos2 >= 1 then ' file saved using the HTMLHELP editor
        flog.writeline "Detected native format, correcting file to be valid XML"
        ' ---- we must convert it to valid XML, unfortunately Microsoft's tool saves to an invalid XML-like format
        set fOldFile = fso.OpenTextFile(Full_out_file,ForReading)
        sOldContsCorrected = ""
        Do While Not fOldFile.AtEndOfStream
          line = fOldFile.ReadLine
          If Instr(1,line,HH_DTD) >= 1 Or Instr(1,line,"<meta name=""GENERATOR""") >= 1 then
            line = ""
          ElseIf Instr(1,line,SITEMAP1) >= 1 Or Instr(1,line,SITEMAP2) >= 1 then
            line="<!-- Sitemap Corrected to be valid XML by Philip Software DocLibTool 1.0 -->"
          ElseIf Instr(1,line,"</OBJECT>") >= 1 then
            line = line & "</LI>"
          ElseIf Instr(1,line,"<param") >= 1 then
            line = line & "</param>"
          End If
          sOldContsCorrected =  sOldContsCorrected & vbCrLf & line
        Loop
        fOldFile.Close
        ' flog.writeline sOldContsCorrected
        ' Save the corrected file so that it can be loaded as XML
        set fOldFile = fso.OpenTextFile(Full_out_file,ForWriting,True)
        fOldFile.Write sOldContsCorrected      
        fOldFile.Close
      end if  ' "found DTD"
     ' -- exit function
     ' -- set olddoc = document(Full_out_file)
      Set olddoc = CreateObject("MSXML2.DOMDocument")
      olddoc.async=false
      olddoc.load Full_out_file
      fLog.Writeline "olddoc DocumentElement=" & olddoc.documentElement.nodeName
      
      ' get collection of all LI nodes (they have the TLB content)
      'set li_nodes = doc.documentElement.getElementsByTagName("LI")  
      'set li_node = li_nodes.item(0) 
      set li_node = doc.documentElement.firstChild.firstChild
      set paramnode=li_node.selectSingleNode("OBJECT/param")
      val = paramnode.getAttribute("value")
      fLog.Writeline "Param value = " & val
      '  <LI><OBJECT type=""text/sitemap"">
      search_str = "//LI[OBJECT/param[@name='Name' and @value='" & val & "']]"
      ' find position of automatically generated content into the old document
      set li_node_old = olddoc.documentElement.selectSingleNode(search_str)
      If li_node_old is nothing then ' rare case
         set nodeParentOld = olddoc.documentElement.selectSingleNode("//BODY/UL")
         set nodeToRemove = nodeParentOld.firstChild
      else
          fLog.writeline "li_node_old exists"
         set nodeParentOld = li_node_old.parentNode ' UL type
         set nodeToRemove = li_node_old
      end if
      ' remove all old generated content
      Do 
        If nodeToRemove Is Nothing Then Exit Do
	fLog.writeline "nodeToRemove type = " & nodeToRemove.nodeName
	' fLog.writeline li_node_old.selectSingleNode("OBJECT/param").getAttribute("value")
        set temp = nodeToRemove.nextSibling 
        call nodeParentOld.removeChild(nodeToRemove)
        set nodeToRemove = temp
      Loop
      set nodeParent = li_node.parentNode ' UL type
      set nodeToPut = nodeParent.firstChild
      Do ' -- while 0
        If nodeToPut Is Nothing Then Exit Do
	 '  set nodeToPut = li_node.cloneNode(True) ' -- doc.documentElement.selectSingleNode(search_str).cloneNode(True)
	 ' Call nodeParent.replaceChild(nodeToPut,nodeToRemove)
	call nodeParentOld.appendChild( nodeToPut.cloneNode(True) )
        set nodeToPut = nodeToPut.nextSibling '.nextNode 
      Loop
      set doc = olddoc ' old non-tool elements + updated tool content for the new lib
      ' append next section up to end
      'SaveLibContentsInHHC_HHK = persistDocument(Full_out_file,doc)
      'Call saveTextFile(Full_out_file,outConts)
      if instr(1,doc.xml,"<HTML>") > 0 then
        outConts = doc.xml
      else
        outConts = "<HTML>" & START_COMM &  doc.xml & END_COMM & "</HTML>"
      end if
      call ReplaceIterative(outConts,">" & vbCrLf,">") ' remove CRs
      call ReplaceIterative(outConts,">" & chr(9),">") ' remove tabs
      SaveLibContentsInHHC_HHK = saveTextFile(Full_out_file,outConts)
      fLog.writeline "File written succesfully !!"
 
    End If ' out file exists
    fLog.Close
  End function

 
  ' save our content between the custom comments shown above
  ' Not used any more because HTMLHelp editor removes these comments
  function SaveLibContentsInHHC_HHK_bak(LibContents,Full_out_file)
   set doc=CreateObject("MSXML2.DOMDocument")
   doc.async=false
   set node=LibContents(0).cloneNode(true)
   doc.appendChild node
   call RemoveDocElemAttributes(doc)
   
    set fIn = fso.OpenTextFile(Full_out_file, ForReading)
    conts = fIn.ReadAll
    fIn.Close
    pos1 = Instr(1,conts,START_COMM) + Len(START_COMM)
    pos2 = Instr(pos1,conts,END_COMM)
    ' part of file up to our content section
    part1 = Left(conts,pos1-1)
    outConts = part1 & vbCrLf & doc.xml & vbCrLf
     ' append next section up to end
    if pos2>0 then outConts = outConts & Mid(conts,pos2)
    SaveLibContentsInHHC_HHK = saveTextFile(Full_out_file,outConts)
  end function

  Sub RemoveDocElemAttributes(doc)
   set attrs = doc.documentElement.attributes
   ' remove xmlns attributes from document element node
   atslen = attrs.length
   Redim atnames(atslen)
   For i=0 To atslen-1
     ' deb = deb & attrs(i).name & vbCrLf 
     atnames(i) = attrs(i).name
   next
   For i=0 To atslen-1
     attrs.removeNamedItem(atnames(i))
   next
  end sub
  
  ']]>
  </msxml:script>

  <msxml:script language="VBScript" implements-prefix="str">'<![CDATA[
   function replaceStr(baseStr,sourceStr,targetStr)
     replaceStr=replace(baseStr,sourceStr,targetStr)
   end function
   
   function evaluate(text)
     evaluate=eval(text)
   end function
   
   function trimtext(text)
     trimtext = trim(text)
   end function
  
  function CRLF2BR(text)
     CRLF2BR = Replace(text,vbLf,"<br>")
  end function
  
  ']]>
  </msxml:script>
  </xsl:stylesheet>
